% script d'introduction  la FFT 2D
% FFT2D d'un signal de type crneau
% auteur P. LE CALLET

	
   % construction d'une image de taille carre
   % d'une onde carre dans une direction
   % on dfinit d'abord les paramtres de l'onde
   % taille = nombre de lignes = nombre de colonnes de l'image carre
   % periode : priode en pixels
   % orientation : orientation en radian
   % amplitude : amplitude de l'onde
   % val_moy : valeur moyenne
   clear all
   close all
   taille = 64
   periode = 8
   orientation = 0
   amplitude = 128
   val_moy = 0
   % on appelle la fonction qui gnre l'image
   im1=generation_carre(taille,periode,amplitude,val_moy);
   % on affiche l'image rsultat
   figure(1); 
   imagesc(im1);
   map = 0:1/255:1;
   map = [map',map',map'];
   colormap(map);
   colorbar;
   % on calcule sa transforme de fourier 
   % on dfinit le nombre de points pour calculer la FFT2D sur une dimension
   nb_point = 8*taille;
   spectre1 = fftshift(fft2(im1,nb_point,nb_point))/(taille*taille);
   %pour avoir le spectre de raies et non les cn
   spectre1 = 2*spectre1;
   spectre1(taille/2+1,taille/2+1)=spectre1(taille/2+1,taille/2+1)/2;
   % on dfinit les vecteurs de frquences normalises
	vt =(-taille/2:taille/nb_point:(taille/2-taille/nb_point))/taille;
   % on affiche le module de la FFT
   figure(2);
	imagesc(vt,vt,(abs(spectre1)));
	colorbar;
   % reprsentation 3D
   figure(3)
   [X,Y]=meshgrid(vt,vt);
	mesh(X,Y,abs(spectre1));


