% To compute 2D FFT
% resolution
% author P. LE CALLET

	
   % To create a square image
   % of a sinus signal in one direction
   % we define the parameters of the signal
   % size1 = row number = column number for a square image
   % period : period in pixels
   % orientation : orientation in radian
   % amplitude : amplitude of the signal
   % dc : continuous DC offset
   clear all
   close all
   size1 = 128
   period = 32
   orientation = pi/4
   amplitude = 128
   dc = 0
   % we call the function for generating the image from the parameters
   im1=generation_sinus(size1,period,orientation,amplitude,dc);
   % to display the result
   figure(1); 
   imagesc(im1);
   map = 0:1/255:1;
   map = [map',map',map'];
   colormap(map);
   colorbar;
   % to compute the FFT
   % number of points for computing the FFT2D according to one dimension
    nb_point = 5*size1;
    spectrum1 = fftshift(fft2(im1,nb_point,nb_point))/(size1*size1);
   % to decrease the DC offset
   spectrum1 = 2*spectrum1;
   spectrum1(size1/2+1,size1/2+1)=spectrum1(size1/2+1,size1/2+1)/2;
   % normalized frequencies
	vt =(-size1/2:size1/nb_point:(size1/2-size1/nb_point))/size1;
   % modulus of the FFT
   figure(2);
   imagesc(vt,vt,(abs(spectrum1)));
   colorbar;
   % 3D plotting
   figure(3)
   [X,Y]=meshgrid(vt,vt);
   mesh(X,Y,abs(spectrum1));
