% filtrage d'image
% filtre passe bas
% auteur P. LE CALLET
%definition de la rponse impulsionnelle d'un filtre 
clear all
close all
support = 5;
filtre = ones(support)/(support*support);

	%calcul et affichage de la fonction de transfert
    %on suppose que l'on filtre des images carres de taille 512
	taille = 512;
    % on calcule sa transforme de fourier (pas de padding)
	spectre_filtre = fftshift(fft2(filtre,taille,taille))/(support*support);
    % on dfinit les vecteurs de frquences normalises
	vt =(-taille/2:taille/taille:(taille/2-taille/taille))/taille;
    % on affiche le module de la FFT
    figure(1);
	imagesc(vt,vt,abs(spectre_filtre));
	colormap('default');
    
    %fin premire partie  

  
	
   % lecture d'une image carr
   im1 = imread('mandrill_lumi.bmp','bmp');
   taille = size(im1,1)
   % on affiche l'image
   figure(2);
   imshow(im1);
   %filtrage en spatial
   imf = conv2(im1,filtre);
   imf2 = conv2(im1,filtre,'same');
   %affichage
   figure(3)
   subplot(1,2,1)
   image(imf)
   map = 0:1/255:1;
   map = [map',map',map'];
   colormap(map);
   subplot(1,2,2)
   image(imf2)
   % fin deuxieme partie
   
   %filtrage spatial avec imfilter
   imf3 = imfilter(im1,filtre);
   imf4 = imfilter(im1,filtre,'replicate');
   %affichage
   figure(4)
   subplot(1,2,1)
   image(imf3)
   subplot(1,2,2)
   image(imf4)
   colormap(map);
   
   %fin troisime partie
   
   %rsultat du filtrage en frquentiel
   % on calcule les transformes de fourier de l'image et de l'image filtre 
   nb_point = taille;
   spectre_im1 = fftshift(fft2(im1,nb_point,nb_point))/(taille*taille);
   spectre_imf4 = fftshift(fft2(imf4,nb_point,nb_point))/(taille*taille);
   vt =(-taille/2:taille/nb_point:(taille/2-taille/nb_point))/taille;
   figure(5);
   subplot(1,2,1)
   imagesc(vt,vt,20*log10(abs(spectre_im1)),[-100,100]);
   subplot(1,2,2)
   imagesc(vt,vt,20*log10(abs(spectre_imf4)),[-100,100]);
   colormap(map)  
   
   